<!DOCTYPE html>
<html lang="en">
  <!-- Copyright 2017 Damien Andre. This file is part of Mechamatic. -->

  <!-- Mechamatic is free software: you can redistribute it and/or modify -->
  <!-- it under the terms of the GNU General Public License as published by -->
  <!-- the Free Software Foundation, either version 3 of the License, or -->
  <!-- () any later version. -->
  
  <!-- Mechamatic is distributed in the hope that it will be useful, -->
  <!-- but WITHOUT ANY WARRANTY; without even the implied warranty of -->
  <!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
  <!-- GNU General Public License for more details. -->
  
  <!-- You should have received a copy of the GNU General Public License -->
  <!-- along with Mechamatic.  If not, see <http://www.gnu.org/licenses/>. -->

  <head>

    <meta charset="utf-8">
    <link rel="icon" type="image/svg+xml" href="./img/logo.svg">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="Online digital image correlation for mechanical characterization">
    <meta name="author" content="Damien André">

    <title>Mechamatic</title>

    <!-- Bootstrap core CSS -->
    <link href="./vendor/bootstrap/css/bootstrap.min.css" rel="stylesheet">

    <!-- Custom fonts for this template -->
    <link href="./vendor/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
    <link href="./vendor/academicons/css/academicons.min.css" rel="stylesheet" type="text/css">

    <!--  Imgareaselect-->
    <link rel="stylesheet" type="text/css" href="./vendor/imgareaselect/css/imgareaselect-animated.css">
    <link rel="stylesheet" type="text/css" href="./vendor/imgareaselect/css/imgareaselect-default.css">
    <link rel="stylesheet" type="text/css" href="./vendor/imgareaselect/css/imgareaselect-deprecated.css">
    
    <!-- Custom styles for this template -->
    <link href="./css/grayscale.css" rel="stylesheet">
    <link href="./css/custom.css" rel="stylesheet">
    <link href="./css/loading.css" rel="stylesheet">
    <link href="./css/loading-btn.css" rel="stylesheet">
    
  </head>

  <body id="page-top">

    <!-- Navigation -->
    <nav class="navbar navbar-expand-lg navbar-light fixed-top" id="mainNav">
      <div class="col-lg-8 text-left">
        <button class="navbar-toggler" id="menu" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
          Menu
          <i class="fa fa-bars"></i>
        </button>
      	<a href="#" class="navbar-left" id="title"><strong>Mechamatic</strong></a>
        <div class="collapse navbar-collapse" id="navbarResponsive">
          <ul class="navbar-nav ml-auto">
	    <li class="nav-item">
              <a class="nav-link" href="index.html"><i class="fa fa-home fa-fw" aria-hidden="true"></i> Home</a>
            </li>
	    <li class="nav-item">
              <a class="nav-link" href="acoustic.html"><i class="fa fa-music fa-fw" aria-hidden="true"></i> Acoustic method</a>
            </li>
	    <li class="nav-item">
              <a class="nav-link" href="optic.html"><i class="fa fa-camera fa-fw" aria-hidden="true"></i> Optic method</a>
            </li>
          </ul>
        </div>
      </div>
      <div class="help-tip" data-toggle="modal" data-target="#helpModal">
	<p>Click here to get some help !</p>
      </div>
    </nav>


    <!-- Intro Header -->
    <header class="masthead dic">
      <div class="intro-body">
        <div class="container">
          <div class="row">
            <div class="col-lg-8 mx-auto">
              <h1 class="brand-heading">Optic method</h1>
	      <div class="loader"></div>
	      <p>loading page...</p>
            </div>
          </div>
        </div>
      </div>
    </header>


    

    <section id="measure" class="content-section-white dic text-left">
      <div class="container">
	<div class="row">
          <div class="col-lg-12 mx-auto">
	   <h1><i class="fa fa-camera fa-fw" aria-hidden="true"></i> Measure</h1>

	   <hr>
	   <form>
	      <div class="form-group row">
		
		<div class="col-md-12">
		  <label>Grid size (in pixel)</label>
		  <div class="input-group">
		    
		    <span class="input-group-addon">width</span>
		    <input type="number" class="form-control" id="grid_x" value="10" step="1" min="1" max="10000">
		    
		    <span class="input-group-addon">height</span>
		    <input type="number" class="form-control" id="grid_y" value="10" step="1" min="1" max="10000">

		    
		  </div>
		</div>
		
		
		<div class="col-md-12">
		  <label>Window size (in pixel)</label>
		  <div class="input-group">
		    
		    <span class="input-group-addon">width</span>
		    <input type="number" class="form-control" id="win_x" value="80" step="1" min="1" max="10000">
		    
		    <span class="input-group-addon">height</span>
		    <input type="number" class="form-control" id="win_y" value="80" step="1" min="1" max="10000">
		    
		  </div>
		</div>
		

		<div class="col-md-12 text-left">
		  <label for="duration">Markers</label>
		  <select class="custom-select input-group" id="marker">
		    <option value="structured" selected>aligned markers</option>
		    <option value="unstructured"      >non-aligned markers</option>
		  </select>
		  <hr>
		</div>

		
		<div class="col-md-12 text-center mt-5"></div>

		
		<div class="col-md-6 text-center">
		  <label><strong>Image of reference</strong></label><br>

		  <label type="button" class="btn btn-default  btn-primary"
			  id="btn-ref-img-file">
		    <i class="fa fa-file-image-o fa-fw" aria-hidden="true"></i> browse...
		    <input type="file" id="ref-img-file" name="files[]" accept="image/*" hidden/>
		  </label>
		  
		  <div class="mt-2"></div>
		  <img id="img-ref" style="width:100%"/>
		</div>

		
		<div class="col-md-6 text-center">
		  <label><strong>Images to process</strong></label><br>
		  <label  type="button" class="btn btn-default  btn-primary"
			  id="btn-process-img-file">
		    <i class="fa fa-file-image-o fa-fw" aria-hidden="true"></i> browse...
		    <input type="file" id="process-img-file" name="files[]" accept="image/*"  multiple/>
		  </label>
		  <div class="mt-2"></div>
		  <img id="img-proc" style="width:100%"/>
		</div>

		<div class="col-md-12 text-center mt-2"></div>

		<div class="col-md-12 text-left">
		  <label for="duration">Data</label>
		  <select class="custom-select input-group" id="data">
		    <option value="spline" selected>smooth data</option>
		    <option value="raw"            >raw data</option>
		  </select>
		  <hr>
		</div>


		<div class="col-md-12 text-center mt-5"></div>

		<div class="col-lg-12 mx-auto text-center mt-2">
		  <button type="button" class="btn btn-primary btn-lg disabled"
			  role="button"  id="run-dic-btn" style="width:75%;" disabled>
		    Compute DIC <i class="fa fa-gear fa-fw" aria-hidden="true"></i>
		  </button>
		</div>
	      </div>
	    </form>	    
          </div>
	</div>
    </section>
    

    <!-- Result Section -->
    <section id="results" class="download-section content-section text-left">
      <div class="container">
	<div class="row">
          <div class="col-lg-12 mx-auto">
	    
	    <h1><i class="fa fa-line-chart fa-fw" aria-hidden="true"></i> Results</h1>
	    <p id="res-msg"><emph>Results are not yet available.
		Please run a digital image correlation process before consulting results.</emph></p>
	  </div>
	  
	  <div class="col-lg-4 mx-auto">
	    <div class="dropdown" id="drop-result" style="visibility:hidden;">
	      <button class="btn btn-success dropdown-toggle" type="button" id="drop-result-btn" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
		Result to display
	      </button>
	      <div class="dropdown-menu" aria-labelledby="drop-result-btn">
		<h6 class="dropdown-header">Choose your results</h6>
		<div class="dropdown-divider"></div>
		<a class="dropdown-item" onclick="plot('strain_xx');"><i class="fa fa-area-chart fa-fw" aria-hidden="true"></i> xx strain map</a>
		<a class="dropdown-item" onclick="plot('strain_yy');"><i class="fa fa-area-chart fa-fw" aria-hidden="true"></i> yy strain map</a>
		<a class="dropdown-item" onclick="plot('strain_xy');"><i class="fa fa-area-chart fa-fw" aria-hidden="true"></i> xy strain map</a>
		<div class="dropdown-divider"></div>
		<a class="dropdown-item" onclick="gif_disp('marker');"><i class="fa fa-film fa-fw" aria-hidden="true"></i> marker animation</a>
		<a class="dropdown-item" onclick="gif_disp('disp');"><i class="fa fa-film fa-fw" aria-hidden="true"></i> displacement animation</a>
		<a class="dropdown-item" onclick="gif_disp('grid');"><i class="fa fa-film fa-fw" aria-hidden="true"></i> grid animation</a>
		<div class="dropdown-divider"></div>
		<a class="dropdown-item" onclick="csv();"><i class="fa fa-download fa-fw" aria-hidden="true"></i>download result files</a>

	      </div>
	      <a href="#" id="csv" download="result.zip" style="display:none;"></a>
	    </div>
	  </div>
	  
	  <div class="col-lg-8 mx-auto">
	    <div class="input-group" style="visibility:hidden;" id="scale_form">
	      <span class="input-group-addon">scale</span>
	      <input type="number" class="form-control" id="scale_gif" value="10" step="0.01" min="0.01"
		     max="100000">
	      <button type="button" class="btn btn-secondary" 
		    id="scale-ok" role="button">OK</button>
	    </div>
	  </div>
	  

	  <div class="col-md-12 text-center">
	    <div id="res" class="plot"></div>
	    <img id="gif" class="plot"/>
	  </div>
      </div>

      <!-- RESULT ARE READY DIALOG -->
      <div class="modal fade" id="result-available-dlg" role="dialog">
	<div class="modal-dialog">
	  <div class="modal-content">
	    <div class="modal-body">
	      <p>Done, you can consult the results now !</p>
	      <a href="#results" id="go-to-measure" class="js-scroll-trigger"
		 style="display:none;">&raquo;</a>
	    </div>
	    <div class="modal-footer">
	      <button type="button" class="btn btn-default"
		      data-dismiss="modal">I got it</button>
	    </div>
	  </div>	
	</div>
      </div>

      
    </section>



    
    <!-- WAIT DIALOG -->
    <div id="process" class="text-center" style="visibility:hidden;">
      <div id="process-msg"></div>
      <div class="loader"></div><h1 class="brand-heading">processing...</h1>
    </div>

    <!-- ZOI DIALOG -->
    <div class="modal fade" id="zoi-modal" role="dialog">
      <div class="modal-dialog">
	<!-- Modal content-->
	<div class="modal-content" id="zoi-parent">
	  <div class="modal-header">
	    <h5 class="modal-title">Select the zone of interest</h5>
	    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
	      <span aria-hidden="true">&times;</span>
	    </button>
	  </div>
	  <div class="modal-body">
	    <img id="img-zoi"/>
	  </div>
	  <div class="modal-footer">
	    <button type="button" class="btn btn-primary" 
		    id="zoi-all-btn" role="button">Select all</button>
	    <button type="button" class="btn btn-primary disabled" 
		    id="zoi-ok-btn" role="button"  aria-disabled="true" disabled>OK</button>
	  </div>
	</div>
      </div>
    </div>


    <!-- CAM DIALOG -->
    <div class="modal fade" id="cam-modal" role="dialog">
      <div class="modal-dialog">
	<!-- Modal content-->
	<div class="modal-content" id="zoi-parent">
	  <div class="modal-header">
	    <h5 class="modal-title">Take a snapshot</h5>
	    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
	      <span aria-hidden="true">&times;</span>
	    </button>
	  </div>
	  <div class="modal-body">
	    <pre id="cam-log"></pre>
	    <video id="cam" autoplay="autoplay" style="width:100%;"></video>
	  </div>
	  <div class="modal-footer">
	    <button type="button" class="btn btn-primary" 
		    id="zoi-ok-btn" role="button" onclick="snapshot();" >Snap</button>
	  </div>
	</div>
      </div>
    </div>


    <!-- HELP -->
    <div class="modal fade" id="helpModal" >
      <div class="modal-dialog" role="document">
	<div class="modal-content">
	  <div class="modal-header">
	    <h5 class="modal-title">Help</h5>
	    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
	      <span aria-hidden="true">&times;</span>
	    </button>
	  </div>
	  <div class="modal-body">
	    <p>The <a href="https://en.wikipedia.org/wiki/Digital_image_correlation">
		digital image correlation</a> (DIC) is a smart and easy optic method able to compute
	      the displacement field of material by comparing two pictures. Here, the DIC is applied for mechanical problems and
	      the proposed application is able to compute 2D strain fields from images. The figure below gives a general
	      overview of the method.
	    </p>
	    <img src="img/dic.png" style="max-width:100%;">
	    <p> 
	      The main problem with the local digital image correlation is the induced noise
	      produced by the data acquisition. This noise impacts dramatically on the results.  
	      The proposed tool embeds a set of numerical algorithms in order to reduce the noise and
	      to compute smoothed strain fields. Another interesting feature is the capability to compute
	      displacement and strain fields from an unstructured set of points. You can enable this option
	      by choosing the <span class="badge badge-primary">Non aligned markers</span> option.
	      Note that the proposed tool is based on <a href="https://gitlab.com/damien.andre/pydic"> pydic</a>,
	      a free Python code for mechanical DIC.</p>

	    <h2>Usage</h2>
	    <p>
	      First, you need to set the grid size and the window size. The <span class="badge badge-primary">grid size</span> are
	      the horizontal and vertical spaces (in pixel) between the correlation windows. 
	      The <span class="badge badge-primary">window size</span> are the horizontal and vertical lengths (in pixel) of the
	      correlation windows.
	    </p>
	    <p>
	      In the mechamatic terminology, a <em>correlation window</em> is a small rectangular area
	      used to compute the DIC and the <em>markers</em> are simply the points located at the center
	      of these correlation windows. 
	    </p>
	    <p>
	      If you want to promote local results, you have to choose
	      a lot of correlation windows with small sizes. In this case, the results may be
	      perturbed by a high level of noise. You can smooth the data by choosing the
	      <span class="badge badge-primary">smooth data</span> option. If you want to promote global results, you have to
	      choose few correlation windows with big sizes. 
	    </p>
	    <p>
	      Secondly, you have to choose your reference image in the <span class="badge badge-primary">Image of reference</span> section.
	      Note that you can choose an image stored on your computer or you can take a live
	      snapshot with your camera. After that, you have to
	      choose one or more other images in the <span class="badge badge-primary">Images to process</span> section
	      for DIC comparison with the reference image.
	    </p>
	    <p>
	      Finally, you can choose if you want to smooth the data or not. <strong>In most
		of cases</strong>, a good choice is the
	      <span class="badge badge-primary">Aligned markers</span> option associated
	      with the <span class="badge badge-primary">Smooth data</span> option.
	    </p>
	    
	    <h2>Results</h2>
	    <p>
	      Many kind of results are available. You can plot the xx, yy and xy strain fields, download a
	      comma separated (*.csv) result file or get some pedagogical gif animations. Many tools,
	      such as spreadsheet software can read *.csv files. It means that you can easily post-treat
	      by yourself the data contained in this file. These data are : the coordinates of the
	      correlation points (markers), their related displacements and their xx, yy, xz strains. 
	      Note that the displayed strain maps correspond to the <strong>last image</strong> from
	      the list that you choose for the DIC process.
	    </p>
	    <h2>Test it now !</h2>
	    <p>
	      If you want to test it now, you can download <a href="./dl/exemple-dic.zip">this archive</a>
	      that contains two images captured during a four point bending test.
	      So, you are able to use these images for testing immediately this me-cha-ma-tic application !
	    </p> 
	    
	    
	  </div>
	  <div class="modal-footer">
	    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
	  </div>
	</div>
      </div>
    </div>
    
    
    
    <!-- Footer -->
    <footer>
      <div class="container text-center">
	<p>Licensed under the <a rel="license" href="./license.txt">GNU-GPL v3 license</a></p>
	<p>Copyright &copy; Damien Andr&eacute; 2017</p>
      </div>
    </footer>

    <!-- Bootstrap core JavaScript -->
    <script src="./vendor/jquery/jquery.min.js"></script>
    <script src="./vendor/popper/popper.min.js"></script>
    <script src="./vendor/bootstrap/js/tether.min.js"></script>
    <script src="./vendor/bootstrap/js/bootstrap.min.js"></script>

    <!-- Plugin JavaScript -->
    <script src="./vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Plotly JS-->
    <script src="vendor/plotly/plotly-latest.min.js"></script>

    
    <!-- imgareaselect -->
    <script src="./vendor/imgareaselect/scripts/jquery.imgareaselect.js"></script>

    <!-- canvas to blob -->
    <script src="./vendor/canvas-to-blob/canvas-to-blob.min.js"></script>

    
    <!-- Custom scripts for this template -->
    <script src="./js/grayscale.js"></script>
    <script src="./js/common.js"></script>
    <script src="./js/optic/main.js"></script>
    <script>
      $(document).ready(function () {
      $('.dropdown-toggle').dropdown();
      });
    </script>
    
  </body>

</html>
